/****************************************************************************/
/* PROGRAMME : DateF                                                        */
/* SOURCE    : datef.c                                                      */
/* VERSION   : 1.0                                                          */
/* AUTEUR    : N. DARNIS                                                    */
/* DATE      : 5.4.1997                                                     */
/* OBJET     : Retourne la date systme au format franais.                 */
/****************************************************************************/

#include <time.h>
#include <fctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define VERSION				{printf( "DateF v 1.0, N. DARNIS, Avril 1997\n\n");}
#define Alloc(t,n)			(t*)malloc(n*sizeof(t))

typedef enum {
	DIM = 0,
	LUN,
	MAR,
	MER,
	JEU,
	VEN,
	SAM,
	ERR_JOUR
} Jour;

typedef enum {
	JAN = 0,
	FEV,
	MARS,
	AVR,
	MAI,
	JUN,
	JUI,
	AOU,
	SEP,
	OCT,
	NOV,
	DEC,
	ERR_MOIS
} Mois;

char *nom_jour[] = {
	"Dimanche",
	"Lundi",
	"Mardi",
	"Mercredi",
	"Jeudi",
	"Vendredi",
	"Samedi",
	"JOUR INCONNU"
};

char *nom_mois[] = {
	"Janvier",
	"Fvrier",
	"Mars",
	"Avril",
	"Mai",
	"Juin",
	"Juillet",
	"Aot",
	"Septembre",
	"Octobre",
	"Novembre",
	"Dcembre",
	"MOIS INCONNU"
};

char *janvier[] = {
	"ERREUR",
	"JOUR DE L'AN",
	"Saint Basile",
	"Sainte Genevive",
	"Saint Odilon",
	"Saint Edouard",
	"Saint Mlaine",
	"Saint Raymond",
	"Saint Lucien",
	"Sainte Alix",
	"Saint Guillaume",
	"Saint Paulin",
	"Sainte Tatiana",
	"Sainte Yvette",
	"Sainte Nina",
	"Saint Remi",
	"Saint Marcel",
	"Sainte Roseline",
	"Sainte Prisca",
	"Saint Marius",
	"Saint Sbastien",
	"Sainte Agns",
	"Saint Vincent",
	"Saint Barnard",
	"Saint Fr. de Sales",
	"Conv. S. Paul",
	"Sainte Paule",
	"Sainte Angle",
	"Saint Th. d'Aquin",
	"Saint Gildas",
	"Sainte Martine",
	"Sainte Marcelle"
};

char *fevrier[] = {
	"ERREUR",
	"Sainte Ella",
	"Prsentation",
	"Saint Blaise",
	"Sainte Vronique",
	"Sainte Agathe",
	"Saint Gaston",
	"Sainte Eugnie",
	"Sainte Jacqueline",
	"Sainte Apolline",
	"Saint Arnaud",
	"N.-D. Lourdes",
	"Saint Flix",
	"Sainte Batrice",
	"Saint Valentin",
	"Saint Claude",
	"Sainte Julienne",
	"Saint Alexis",
	"Sainte Bernadete",
	"Saint Gabin",
	"Sainte Aime",
	"Saint P. Damien",
	"Sainte Isabelle",
	"Saint Lazare",
	"Saint Modeste",
	"Saint Romo",
	"Saint Nestor",
	"Sainte Honorine",
	"Saint Romain",
	"Saint Auguste",
};

char *mars[] = {
	"ERREUR",
	"Saint Aubin",
	"Saint Charles le B.",
	"Saint Gunol",
	"Saint Casimir",
	"Saint Olive",
	"Sainte Colette",
	"Sainte Flicit",
	"Saint Jean de D.",
	"Sainte Franoise",
	"Saint Vivien",
	"Sainte Rosine",
	"Sainte Justine",
	"Saint Rodrigue",
	"Sainte Mathilde",
	"Sainte Louise",
	"Sainte Bndicte",
	"Saint Patrice",
	"Saint Cyrille",
	"Saint Joseph",
	"Saint Herbert",
	"Sainte Clmence",
	"Sainte La",
	"Saint Victorien",
	"Sainte Cath. de Su.",
	"ANNONCIATION",
	"Sainte Larissa",
	"Saint Habib",
	"Saint Gontran",
	"Sainte Gwladys",
	"Saint Amde",
	"Saint Benjamin"
};

char *avril[] = {
	"ERREUR",
	"Saint Hugues",
	"Sainte Sandrine",
	"Saint Richard",
	"Saint Isidore",
	"Sainte Irne",
	"Saint Marcelin",
	"Saint J.-B. de la S.",
	"Sainte Julie",
	"Saint Gautier",
	"Saint Fulbert",
	"Saint Stanislas",
	"Saint Jules",
	"Sainte Ida",
	"Saint Maxime",
	"Saint Paterne",
	"Saint Benot-J.",
	"Saint Anicet",
	"Saint Parfait",
	"Sainte Emma",
	"Sainte Odette",
	"Saint Anselme",
	"Saint Alexandre",
	"Saint Georges",
	"Saint Fidle",
	"Saint Marc",
	"Sainte Alida",
	"Sainte Zita",
	"Sainte Valrie",
	"Sainte Cath. de Si.",
	"Saint Robert"
};

char *mai[] = {
	"ERREUR",
	"FETE DU TRAVAIL",
	"Saint Boris",
	"Saint Jacques, Saint Philippe",
	"Saint Sylvain",
	"Sainte Judith",
	"Sainte Prudence",
	"Sainte Gisle",
	"VICTOIRE 1945",
	"Saint Pacme",
	"Sainte Solange",
	"Sainte Estelle",
	"Saint Achille",
	"Sainte Rolande",
	"Saint Matthias",
	"Sainte Denise",
	"Saint Honor",
	"Saint Pascal",
	"Saint Eric",
	"Saint Yves",
	"Saint Bernardin",
	"Saint Constantin",
	"Saint Emile",
	"Saint Didier",
	"Saint Donatien",
	"Sainte Sophie",
	"Saint Brenger",
	"Saint Augustin",
	"Saint Germain",
	"Saint Aymar",
	"Saint Ferdinand",
	"Visitation"
};

char *juin[] = {
	"ERREUR",
	"Saint Justin",
	"Sainte Blandine",
	"Saint Kvin",
	"Sainte Clotilde",
	"Saint Igor",
	"Saint Norbert",
	"Saint Gilbert",
	"Saint Mdard",
	"Sainte Diane",
	"Saint Landry",
	"Saint Barnab",
	"Saint Guy",
	"Saint Antoine de P.",
	"Saint Elise",
	"Sainte Germaine",
	"Saint J.F. Rgis",
	"Saint Herv",
	"Saint Lonce",
	"Saint Romuald",
	"Saint Silvre",
	"ETE",
	"Saint Alban",
	"Sainte Audrey",
	"Saint Jean-Bapt.",
	"Saint Prosper",
	"Saint Anthelme",
	"Saint Fernand",
	"Saint Irne",
	"Saint Pierre, Saint Paul",
	"Saint Martial"
};

char *juillet[] = {
	"ERREUR",
	"Saint Thierry",
	"Saint Martinien",
	"Saint Thomas",
	"Saint Florent",
	"Saint Antoine",
	"Sainte Mariette",
	"Saint Raoul",
	"Saint Thibaut",
	"Sainte Amandine",
	"Saint  Ulrich",
	"Saint Benot",
	"Saint Olivier",
	"Saint Henri, Saint Jol",
	"FETE NATIONALE",
	"Saint Donald",
	"N.D. Mt-Carmel",
	"Sainte Charlotte",
	"Saint Frdric",
	"Saint Arsne",
	"Sainte Marina",
	"Saint Victor",
	"Sainte Marie-Mad.",
	"Sainte Brigitte",
	"Sainte Christine",
	"Saint Jacques",
	"Sainte Anne, Sainte Joa.",
	"Sainte Nathalie",
	"Saint Samson",
	"Sainte Marthe",
	"Sainte Juliette",
	"Saint Ignace de L."
};

char *aout[] = {
	"ERREUR",
	"Saint Alphonse",
	"Saint Julien-Ey.",
	"Sainte Lydie",
	"Saint J.M. Vianney",
	"Saint Abel",
	"Transfiguration",
	"Saint Gatan",
	"Saint Dominique",
	"Saint Amour",
	"Saint Laurent",
	"Sainte Claire",
	"Sainte Clarisse",
	"Saint Hippolyte",
	"Saint Evrard",
	"ASSOMPTION",
	"Saint Armel",
	"Saint Hyacinthe",
	"Sainte Hlne",
	"Saint Jean Eudes",
	"Saint Bernard",
	"Saint Christophe",
	"Saint Fabrice",
	"Sainte Rose de L.",
	"Saint Barthlemy",
	"Saint Louis",
	"Sainte Natacha",
	"Sainte Monique",
	"Saint Augustin",
	"Sainte Sabine",
	"Saint Fiacre",
	"Saint Aristide"
};

char *septembre[] = {
	"ERREUR",
	"Saint Gilles",
	"Sainte Ingrid",
	"Saint Grgoire",
	"Sainte Rosalie",
	"Sainte Rassa",
	"Saint Bertrand",
	"Sainte Reine",
	"Nativit N.D.",
	"Saint Alain",
	"Sainte Ins",
	"Saint Adelphe",
	"Saint Apollinaire",
	"Saint Aim",
	"La Sainte Croix",
	"Saint Roland",
	"Sainte Edith",
	"Saint Renaud",
	"Sainte Nadge",
	"Sainte Emilie",
	"Saint Davy",
	"Saint Matthieu",
	"Saint Maurice",
	"AUTOMNE",
	"Sainte Thcle",
	"Saint Hermann",
	"Saint Cme, Saint Dam.",
	"Saint Vincent de Paul",
	"Saint Venceslas",
	"Saint Michel",
	"Saint Jrme"
};

char *octobre[] = {
	"ERREUR",
	"Sainte Th. de l'E.J.",
	"Saint Lger",
	"Saint Grard",
	"Saint Fr. d'Assise",
	"Sainte Fleur",
	"Saint Bruno",
	"Saint Serge",
	"Sainte Plagie",
	"Saint Denis",
	"Saint Ghislain",
	"Saint Firmin",
	"Saint Wilfried",
	"Saint Graud",
	"Saint Juste",
	"Sainte Th. d'Avila",
	"Sainte Edwige",
	"Saint Baudouin",
	"Saint Luc",
	"Saint Ren",
	"Sainte Adeline",
	"Sainte Cline",
	"Sainte Elodie",
	"Saint Jean de C.",
	"Saint Florentin",
	"Saint Crpin",
	"Saint Dimitri",
	"Sainte Emeline",
	"Saint Sim., Saint Jude",
	"Saint Narcisse",
	"Sainte Bienvenue",
	"Saint Quentin"
};

char *novembre[] = {
	"ERREUR",
	"TOUSSAINT",
	"DEFUNTS",
	"Saint Hubert",
	"Saint Charles",
	"Sainte Sylvie",
	"Sainte Bertille",
	"Sainte Carine",
	"Saint Geoffroy",
	"Saint Thodore",
	"Saint Lon",
	"ARMISTICE 1918",
	"Saint Christian",
	"Saint Brice",
	"Saint Sidoine",
	"Saint Albert",
	"Sainte Marguerite",
	"Sainte Elisabeth",
	"Sainte Aude",
	"Saint Tanguy",
	"Saint Edmond",
	"Prs. Marie",
	"Sainte Ccile",
	"Saint Clment",
	"Sainte Flora",
	"Sainte Catherine L.",
	"Sainte Delphine",
	"Saint Sverin",
	"Saint Jacq. de la M.",
	"Saint Saturnin",
	"Saint Andr"
};

char *decembre[] = {
	"ERREUR",
	"Sainte Florence",
	"Sainte Viviane",
	"Saint Xavier",
	"Sainte Barbara",
	"Saint Grald",
	"Saint Nicolas",
	"Saint Ambroise",
	"Imm. Concept.",
	"Saint P. Fourier",
	"Saint Romaric",
	"Saint Daniel",
	"Sainte Jeanne F.C.",
	"Sainte Lucie",
	"Sainte Odile",
	"Sainte Ninon",
	"Sainte Alice",
	"Saint Gal",
	"Saint Gatien",
	"Saint Urbain",
	"Saint Abraham",
	"Saint Pierre C.",
	"HIVER",
	"Saint Armand",
	"Sainte Adle",
	"NOEL",
	"Saint Etienne",
	"Saint Jean",
	"SS. Innoncents",
	"Saint David",
	"Saint Roger",
	"Saint Sylvestre"
};

void main( int argc, char *argv[] );
void Usage( void );
void Erreur( void );

void main( int argc, char *argv[] )
{
	short					r = 0;
	long					h,
							m;
	struct tm				*t;
	char					*k,
							*jour,
							*mois,
							*fete = NULL,
							jr[4],
							heures[3],
							minutes[3];
	time_t					y,
							z;

	if( argc > 2 )
		Usage();
	 
	if( argc == 2 )
		if( !isdigit( *argv[1] ) )
			Usage();

	y = time( &z );
	t = localtime( &y );
	k = asctime( t );

	if( argc == 2 )
	{
		strncpy( heures, argv[1], 2 );
		strncpy( minutes, strchr( argv[1], ':' ) + 1, 2 );
		h = strtol( heures, NULL, 10 );
		m = strtol( minutes, NULL, 10 );

		if( h <= 23 && h >= 0 && m <= 59 && m >= 0 )
		{
			if( (long)t->tm_hour >= h )
			{
				if( (long)t->tm_min >= m )
					r = 30;
			}
		}
	}

	strncpy( jr, k, 3 );
	jr[3] = '\0';

	if( !strcmpi( "sun", jr ) )
	{
		jour = Alloc( char, 1 + strlen( nom_jour[DIM] ) );
		strcpy( jour, nom_jour[DIM] );
	}
	else
	{
		if( !strcmpi( "mon", jr ) )
		{
			jour = Alloc( char, 1 + strlen( nom_jour[LUN] ) );
			strcpy( jour, nom_jour[LUN] );
		}
		else
		{
			if( !strcmpi( "tue", jr ) )
			{
				jour = Alloc( char, 1 + strlen( nom_jour[MAR] ) );
				strcpy( jour, nom_jour[MAR] );
			}
			else
			{
				if( !strcmpi( "wed", jr ) )
				{
					jour = Alloc( char, 1 + strlen( nom_jour[MER] ) );
					strcpy( jour, nom_jour[MER] );
				}
				else
				{
					if( !strcmpi( "thu", jr ) )
					{
						jour = Alloc( char, 1 + strlen( nom_jour[JEU] ) );
						strcpy( jour, nom_jour[JEU] );
					}
					else
					{
						if( !strcmpi( "fri", jr ) )
						{
							jour = Alloc( char, 1 + strlen( nom_jour[VEN] ) );
							strcpy( jour, nom_jour[VEN] );
						}
						else
						{
							if( !strcmpi( "sat", jr ) )
							{
								jour = Alloc( char, 1 + strlen( nom_jour[SAM] ) );
								strcpy( jour, nom_jour[SAM] );
							}
							else
							{
								jour = Alloc( char, 1 + strlen( nom_jour[ERR_JOUR] ) );
								strcpy( jour, nom_jour[ERR_JOUR] );
							}
						}
					}
				}
			}
		}
	}

	switch( t->tm_mon )
	{
		case JAN:
			mois = Alloc( char, 1 + strlen( nom_mois[JAN] ) );
			strcpy( mois, nom_mois[JAN] );
			fete = Alloc( char, 1 + strlen( janvier[t->tm_mday] ) );
			strcpy( fete, janvier[t->tm_mday] );
			break;

		case FEV:
			mois = Alloc( char, 1 + strlen( nom_mois[FEV] ) );
			strcpy( mois, nom_mois[FEV] );
			fete = Alloc( char, 1 + strlen( fevrier[t->tm_mday] ) );
			strcpy( fete, fevrier[t->tm_mday] );
			break;

		case MARS:
			mois = Alloc( char, 1 + strlen( nom_mois[MARS] ) );
			strcpy( mois, nom_mois[MARS] );
			fete = Alloc( char, 1 + strlen( mars[t->tm_mday] ) );
			strcpy( fete, mars[t->tm_mday] );
			break;

		case AVR:
			mois = Alloc( char, 1 + strlen( nom_mois[AVR] ) );
			strcpy( mois, nom_mois[AVR] );
	 		fete = Alloc( char, 1 + strlen( avril[t->tm_mday] ) );
			strcpy( fete, avril[t->tm_mday] );
			break;
	
		case MAI:
			mois = Alloc( char, 1 + strlen( nom_mois[MAI] ) );
			strcpy( mois, nom_mois[MAI] );
	 		fete = Alloc( char, 1 + strlen( mai[t->tm_mday] ) );
			strcpy( fete, mai[t->tm_mday] );
			break;

		case JUN:
			mois = Alloc( char, 1 + strlen( nom_mois[JUN] ) );
			strcpy( mois, nom_mois[JUN] );
			fete = Alloc( char, 1 + strlen( juin[t->tm_mday] ) );
			strcpy( fete, juin[t->tm_mday] );
			break;

		case JUI:
			mois = Alloc( char, 1 + strlen( nom_mois[JUI] ) );
			strcpy( mois, nom_mois[JUI] );
	 		fete = Alloc( char, 1 + strlen( juillet[t->tm_mday] ) );
			strcpy( fete, juillet[t->tm_mday] );
			break;

		case AOU:
			mois = Alloc( char, 1 + strlen( nom_mois[AOU] ) );
			strcpy( mois, nom_mois[AOU] );
	 		fete = Alloc( char, 1 + strlen( aout[t->tm_mday] ) );
			strcpy( fete, aout[t->tm_mday] );
			break;

		case SEP:
			mois = Alloc( char, 1 + strlen( nom_mois[SEP] ) );
			strcpy( mois, nom_mois[SEP] );
	 		fete = Alloc( char, 1 + strlen( septembre[t->tm_mday] ) );
			strcpy( fete, septembre[t->tm_mday] );
			break;

		case OCT:
			mois = Alloc( char, 1 + strlen( nom_mois[OCT] ) );
			strcpy( mois, nom_mois[OCT] );
	 		fete = Alloc( char, 1 + strlen( octobre[t->tm_mday] ) );
			strcpy( fete, octobre[t->tm_mday] );
			break;

		case NOV:
			mois = Alloc( char, 1 + strlen( nom_mois[NOV] ) );
			strcpy( mois, nom_mois[NOV] );
	 		fete = Alloc( char, 1 + strlen( novembre[t->tm_mday] ) );
			strcpy( fete, novembre[t->tm_mday] );
			break;

		case DEC:
			mois = Alloc( char, 1 + strlen( nom_mois[DEC] ) );
			strcpy( mois, nom_mois[DEC] );
	 		fete = Alloc( char, 1 + strlen( decembre[t->tm_mday] ) );
			strcpy( fete, decembre[t->tm_mday] );
			break;

		default:
			mois = Alloc( char, 1 + strlen( nom_mois[ERR_MOIS] ) );
			strcpy( mois, nom_mois[ERR_MOIS] );
			break;
	}

	if( t->tm_mday == 1 )
		printf( "%s %der %s %d, ", jour, t->tm_mday, mois, t->tm_year + 1900 );
	else
		printf( "%s %d %s %d, ", jour, t->tm_mday, mois, t->tm_year + 1900 );

	printf( "%d:", t->tm_hour );

	if( t->tm_min < 10 ) printf( "0%d:", t->tm_min )
		;
	else
		printf( "%d:", t->tm_min );

	if( t->tm_sec < 10 ) printf( "0%d, ", t->tm_sec )
		;
	else
		printf( "%d, ", t->tm_sec );

	printf( "%s\n", fete );

	heures[0] = NULL;
	minutes[0] = NULL;

	if( mois ) free( mois );
	if( jour ) free( jour );
	if( fete ) free( fete );

	exit( r );
}

void Usage( void )
{
	VERSION;
	printf( "    Utilisation :\n\n");
	printf( "\t1- DateF       : Retourne la date et l'heure systme ainsi que la fte\n\t\t\t du jour du calendrier franais.\n" );
	printf( "\t2- DateF hh:mm : Idem mais renvoie la valeur 30 si l'heure systme\n" );
	printf( "\t                 est suprieure ou gale  hh:mm (idal pour se faire\n" );
	printf( "\t                 une alarme CLI).\n" );
	exit( 1 );
}

void Erreur( void )
{
	printf( "DateF : ERREUR\n" );
	exit( -1 );
}
